/* @(#) pfcompil.h 96/12/18 1.11 */

#ifndef _pforth_compile_h
#define _pforth_compile_h

/***************************************************************
** Include file for PForth Compiler
**
** Author: Phil Burk
** Copyright 1994 3DO, Phil Burk, Larry Polansky, Devid Rosenboom
**
** The pForth software code is dedicated to the public domain,
** and any third party may reproduce, distribute and modify
** the pForth software code or any derivative works thereof
** without any compensation or license.  The pForth software
** code is provided on an "as is" basis without any warranty
** of any kind, including, without limitation, the implied
** warranties of merchantability and fitness for a particular
** purpose and their equivalents under the laws of any jurisdiction.
**
***************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

int32 FindSpecialCFAs( void );
cell *NameToCode( ForthString *NFA );
const ForthString *NameToPrevious( const ForthString *NFA );

cfDictionary *pfBuildDictionary( int32 HeaderSize, int32 CodeSize );
void CreateDicEntry( ExecToken XT, const ForthStringPtr FName, uint32 Flags );
void CreateDicEntryC( ExecToken XT, const char *CName, uint32 Flags );

void  ffAbort( void );
void  ffColon( void );
void  ffCreate( void );
int32 FindSpecialXTs( void );
void  ffStringCreate( ForthStringPtr FName);
ExecToken NameToToken( const ForthString *NFA );
void  ffDefer( void );
void  ffStringDefer( const ForthStringPtr FName, ExecToken DefaultXT );
cell  ffTokenToName( ExecToken XT, const ForthString **NFAPtr );
cell  ffFind( const ForthString *WordName, ExecToken *pXT );
cell  ffFindC( const char *WordName, ExecToken *pXT );
cell  ffNumberQ( const char *FWord, cell *Num );
cell  ffRefill( void );
char *ffWord( char c );
void  ffOK( void );
void  ffCreateSecondaryHeader( const ForthStringPtr FName);
void  ffQuit( void );
FileStream *ffPopInputStream( void );
Err   ffPushInputStream( FileStream *InputFile );
cell  ffConvertStreamToSourceID( FileStream *Stream );
void  ffALiteral( cell Num );
cell  ffFindNFA( const ForthString *WordName, const ForthString **NFAPtr );
int32 ffInterpret( void );
cell  ffIncludeFile( FileStream *InputFile );
void  ffLiteral( cell Num );
void  ff2Literal( cell dHi, cell dLo );
void  ffSemiColon( void );
int32 NotCompiled( const char *FunctionName );

#ifdef PF_SUPPORT_FP
void ffFPLiteral( PF_FLOAT fnum );
#endif

#ifdef __cplusplus
}   
#endif

#endif /* _pforth_compile_h */
